<template>
  <label :for="id" :class="['label-radio', isChecked ? 'input-selected' : '']">
    <input
      type="radio"
      :id="id"
      :value="id"
      :name="name"
      @click="triggerPeriod"
      class="input-radio"
    />
    <div class="wrapper-radio-label">
      <img
        v-if="isChecked"
        :src="img(imageSelected)"
        loading="lazy"
        class="switch-img"
      />
      <img v-else :src="img(image)" loading="lazy" class="switch-img" />
      <span class="radio-text">{{ title }}</span>
    </div>
    <div class="checkmark">
      <span class="checkmark-center"></span>
    </div>
  </label>
</template>

<script lang="ts" setup>
import { img } from '@/utils/image'
const emit = defineEmits<{ (e: 'trigger', value: string): void }>()
defineProps({
  name: {
    type: String,
    default: ''
  },
  title: {
    type: String,
    default: ''
  },
  id: {
    type: String,
    default: ''
  },
  image: {
    type: String,
    default: ''
  },
  imageSelected: {
    type: String,
    default: ''
  },
  isChecked: {
    type: Boolean,
    default: false
  }
})
function triggerPeriod(event: MouseEvent) {
  const target = event.target as HTMLInputElement
  emit('trigger', target.value)
}
</script>

<style scoped lang="scss">
.label-radio {
  width: 100%;
  border: 0.15rem solid var(--blue-semi);
  padding: 1.5rem;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  border-radius: 1rem;
  &:first-child {
    margin-right: 1rem;
  }
  &:last-child {
    margin-left: 1rem;
  }
}
.input-selected {
  border-color: var(--blue);
  .radio-text {
    color: var(--blue);
  }
  .checkmark-center {
    height: 1rem;
    width: 1rem;
    background-color: var(--white);
    border-radius: 50%;
  }
  .checkmark {
    background-color: var(--blue);
  }
}
.input-radio {
  position: absolute;
  opacity: 0;
}
.wrapper-radio-label {
  display: flex;
  flex-direction: column;
}
.switch-img {
  height: 3rem;
}
.radio-text {
  margin-top: 1rem;
  text-align: center;
}
.checkmark {
  position: absolute;
  top: 1rem;
  left: 1rem;
  height: 2.5rem;
  width: 2.5rem;
  background-color: var(--blue-pale);
  border-radius: 50%;
  border: 0.15rem solid var(--blue-semi);
  display: flex;
  justify-content: center;
  align-items: center;
}
@media (max-width: 500px) {
  .checkmark {
    top: 0.5rem;
    left: 0.5rem;
    height: 1.5rem;
    width: 1.5rem;
    .checkmark-center {
      height: 0.5rem;
      width: 0.5rem;
    }
  }
  .label-radio {
    margin-bottom: 1rem;
    padding: 1rem;
  }
  .switch-img {
    height: 2rem;
  }
  .radio-text {
    font-size: 1.2rem;
    margin-top: 0.5rem;
  }
}
</style>
